<id>
Topic Ratings
</id>

<version>
1.02
</version>

<mod info>
This MOD allows you to specify boards in which ratings can be given for each topic. At the moment all registered members can rate a topic depending on quality. The rating is shown in the message index and in the topic itself.

Installation Instructions:
1) Upload Ratingsdb.php to your forum root and run it ONCE, then delete it
2) Install this mod file and upload the changes

Hope you enjoy this release

Grudge
</mod info>

<author>
Grudge
</author>

<homepage>
www.mymods.co.uk
</homepage>

<edit file>
$sourcedir/Display.php
</edit file>

<search for>
		$context['sub_template'] = WIRELESS_PROTOCOL . '_display';
	else
		loadTemplate('Display');
</search for>

<add after>
	// If they are changing the topic rating do a little logic...
	if (isset($_REQUEST['rate_it']) && !$user_info['is_guest'])
	{
		$rating = (int) $_POST['rating'];

		// If it's legal update the topic information.
		if ($rating >= 0 && $rating < 6)
			db_query("
				REPLACE INTO {$db_prefix}log_ratings
					(ID_MEMBER, ID_TOPIC, rating)
				VALUES
					($ID_MEMBER, $topic, $rating)", __FILE__, __LINE__);
		// Do a little logic to calculate the new topic rating and update the topics table.
		$request = db_query("
			SELECT COUNT(ID_MEMBER) AS totalMembers, SUM(rating) AS totalRating
			FROM {$db_prefix}log_ratings
			WHERE ID_TOPIC = $topic
			LIMIT 1", __FILE__, __LINE__);
		list ($totalMembers, $totalRatings) = mysql_fetch_row($request);
		mysql_free_result($request);

		$totalRatings = $totalRatings * 2;
		// Now we can, of course, calculate the new total, and update the topic accordingly!
		$topicRating = $totalMembers != 0 ? (int) ($totalRatings / $totalMembers) : -1;

		if ($topicRating >= -1 && $topicRating < 11)
			db_query("
				UPDATE {$db_prefix}topics
				SET rating = $topicRating
				WHERE ID_TOPIC = $topic", __FILE__, __LINE__);
	}
</add after>

<search for>
	// Get all the important topic info.
	$request = db_query("
		SELECT
			t.numReplies, t.numViews, t.locked, ms.subject, t.isSticky, t.ID_POLL, t.ID_MEMBER_STARTED,
</search for>

<add after>
			IFNULL(lr.rating, -1) AS pastRating, t.rating,
</add after>

<search for>
		FROM {$db_prefix}topics AS t, {$db_prefix}messages AS ms
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = $topic AND lt.ID_MEMBER = $ID_MEMBER)
</search for>

<add after>
			LEFT JOIN {$db_prefix}log_ratings AS lr ON (lr.ID_TOPIC = $topic AND lr.ID_MEMBER = $ID_MEMBER)
</add after>

<search for>
	$context['num_replies'] = $topicinfo['numReplies'];
	$context['topic_first_message'] = $topicinfo['ID_FIRST_MSG'];
</search for>

<add after>

	// Little information about the ratings for this topic.
	$context['can_rate'] = $board_info['is_rated'] ? $topicinfo['pastRating'] : NULL;
	if ($context['can_rate'] !== NULL)
		$context['rating'] = array(
			'empty' => $topicinfo['rating'] == -1,
			'whole' => (int) ($topicinfo['rating'] / 2),
			'half' => $topicinfo['rating'] % 2
		);
</add after>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
			b.ID_THEME, b.override_theme, b.use_local_permissions
</search for>

<add after>
			,b.is_rated
</add after>

<search for>
			'theme' => $row['ID_THEME'],
			'override_theme' => !empty($row['override_theme']),
</search for>

<add after>
			'is_rated' => $row['is_rated'],
</add after>

<edit file>
$sourcedir/ManageBoards.php
</edit file>

<search for>
		$_POST['count'] = isset($_POST['count']) ? '0' : '1';
</search for>

<add after>
		$_POST['is_rated'] = isset($_POST['is_rated']) ? '1' : '0';
</add after>

<search for>
				UPDATE {$db_prefix}boards
				SET
					name = '$_POST[board_name]', description = '$_POST[desc]', memberGroups = '" . implode(',', $_POST['groups']) . "',
</search for>

<add after>
					is_rated = $_POST[is_rated],
</add after>

<search for>
					childLevel, boardOrder, ID_THEME, override_theme)
</search for>

<replace>
					childLevel, boardOrder, ID_THEME, override_theme, is_rated)
</replace>

<search for>
					$childLevel, $spot, $_POST[boardtheme], $_POST[override_theme])", __FILE__, __LINE__);
</search for>

<replace>
					$childLevel, $spot, $_POST[boardtheme], $_POST[override_theme], $_POST[is_rated])", __FILE__, __LINE__);
</replace>

<search for>

	$request = db_query("
		SELECT
			IFNULL(b.ID_BOARD, 0) AS ID_BOARD, b.ID_PARENT, b.name AS bName, b.description, b.childLevel,
</search for>

<add after>
			b.is_rated,
</add after>

<search for>
				'theme' => $row['ID_THEME'],
				'override_theme' => $row['override_theme'],
</search for>

<add after>
				'is_rated' => $row['is_rated'],
</add after>

<edit file>
$sourcedir/ManageMembers.php
</edit file>

<search for>
	db_query("
		DELETE FROM {$db_prefix}log_online
		WHERE ID_MEMBER $condition", __FILE__, __LINE__);
</search for>

<add after>
	// This one won't take effect immediatly... but oh well.
	db_query("
		DELETE FROM {$db_prefix}log_ratings
		WHERE ID_MEMBER $condition", __FILE__, __LINE__);
</add after>

<edit file>
$sourcedir/MessageIndex.php
</edit file>

<search for>
	$context['name'] = $board_info['name'];
	$context['description'] = $board_info['description'];
</search for>

<add after>
	$context['show_rating'] = $board_info['is_rated'];
</add after>

<search for>
		'replies' => 't.numReplies',
		'views' => 't.numViews',
</search for>

<add after>
		'rating' => 't.rating',
</add after>

<search for>
	$result = db_query("
		SELECT
			t.ID_TOPIC, t.numReplies, t.locked, t.numViews, t.isSticky, t.ID_POLL,
</search for>

<add after>
			t.rating,
</add after>

<search for>
			'newtime' => $row['isRead'],
</search for>

<add after>
			'rating' => array(
				'empty' => $row['rating'] == -1,
				'whole' => (int) ($row['rating'] / 2),
				'half' => $row['rating'] % 2
			),
</add after>

<edit file>
$sourcedir/RemoveTopic.php
</edit file>

<search for>
	db_query("
		DELETE FROM {$db_prefix}log_notify
		WHERE ID_TOPIC $condition", __FILE__, __LINE__);
</search for>

<add after>
	db_query("
		DELETE FROM {$db_prefix}log_ratings
		WHERE ID_TOPIC $condition", __FILE__, __LINE__);
</add after>

<edit file>
$themedir/Display.template.php
</edit file>

<search for>
	// Show the topic information - icon, subject, etc.
	echo '
</search for>

<add before>
// Can they rate the topic?
if ($context['can_rate'] !== NULL)
{
	echo '
<table width="100%" cellpadding="3" cellspacing="0" border="0" class="tborder" style="margin-bottom: 1ex;">
	<tr valign="middle">
		<td align="left" class="windowbg"><b>';
	if ($context['rating']['empty'])
		echo $txt['ratings_not_rated'];
	else
	{
		echo $txt['ratings_current_rating'], ': ';
		for ($i = 0; $i < $context['rating']['whole']; $i++)
			echo '<img src="', $settings['images_url'], '/star.gif" alt="*" border="0" />';
		//!!! Should have a half star!
		if (!empty($context['rating']['half']))
			echo '<img src="', $settings['images_url'], '/star.gif" alt="*" border="0" />';
	}
	echo '
		</b></td>
		<td align="right" class="windowbg">
			<form action="', $scripturl, '?topic=', $context['current_topic'], '.', $context['start'], '" method="post" style="margin: 0;">
				', $context['can_rate'] == -1 ? $txt['ratings_you_not_rated'] : $txt['ratings_you_have_rated'], '
				<select name="rating">';
		for ($i = 0; $i < 6; $i++)
			echo '
					<option value="', $i, '" ', $context['can_rate'] == $i ? 'selected="selected"' : '', '>', $i, '</option>';
		echo '
				</select>
				<input type="submit" value="', $txt[161], '" />
				<input type="hidden" name="rate_it" value="1" />
			</form>
		</td>
	</tr>
</table>';
}
</add before>

<edit file>
$themedir/ManageBoards.template.php
</edit file>

<search for>
								<td valign="top" align="right">
									<input type="checkbox" name="override_theme"', $context['board']['override_theme'] ? ' checked="checked"' : '', ' class="check" />
								</td>
</search for>

<add after>
							</tr><tr>
								<td>
									<b>', $txt['ratings_board'], '</b><br />
									', $txt['ratings_board_desc'], '<br /><br />
								</td>
								<td valign="top" align="right">
									<input type="checkbox" name="is_rated"', $context['board']['is_rated'] ? ' checked="checked"' : '', ' class="check" />
								</td>
</add after>

<edit file>
$themedir/MessageIndex.template.php
</edit file>

<search for>
					<td width="4%" align="center"><a href="', $scripturl, '?board=', $context['current_board'], '.', $context['start'], ';sort=views', $context['sort_by'] == 'views' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt[301], $context['sort_by'] == 'views' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>
</search for>

<add after>
					';
		if ($context['show_rating'])
			echo '
					<td width="8%" align="center"><a href="', $scripturl, '?board=', $context['current_board'], '.', $context['start'], ';sort=rating', $context['sort_by'] == 'rating' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['ratings_rating'], $context['sort_by'] == 'rating' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>';
		echo '
</add after>

<search for>
					<td class="windowbg" valign="middle" width="4%" align="center">
						', $topic['views'], '
					</td>
</search for>

<add after>
					';
		if ($context['show_rating'])
		{
			echo '
					<td class="windowbg" valign="middle" width="8%" align="center">';
			if ($topic['rating']['empty'] == 1)
				echo 'N/A';
			else
			{
				for ($i = 0; $i < $topic['rating']['whole']; $i++)
					echo '<img src="', $settings['images_url'], '/star.gif" alt="*" border="0" />';
				//!!! Should have a half star!
				if (!empty($topic['rating']['half']))
					echo '<img src="', $settings['images_url'], '/star.gif" alt="*" border="0" />';
			}
			echo '
					</td>';
		}
		echo '
</add after>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
?>
</search for>

<add before>
$txt['ratings_rating'] = 'Rating';

$txt['ratings_board'] = 'Enable Ratings on this Board';
$txt['ratings_board_desc'] = 'With this option enabled members will be able to rate the quality of a topic on this board.';

$txt['ratings_you_not_rated'] = 'You have not rated this topic. Select a rating:';
$txt['ratings_you_have_rated'] = 'You have already rated this topic. You may change your rating at any time:';
$txt['ratings_current_rating'] = 'Current Topic Rating';
$txt['ratings_not_rated'] = 'This topic has not yet been rated!';
</add before>